Crypto++ 8.1 Free C++ class library of cryptographic schemes

Public Member Functions | Static Public Member Functions | Static Public Attributes | List of all members
SHAKE_Final< T_Strength > Class Template Reference

SHAKE message digest template. More...

Inheritance diagram for SHAKE_Final< T_Strength >:

## Public Member Functions
| SHAKE_Final (unsigned int outputSize=DIGESTSIZE)
| Construct a SHAKE-X message digest. More...
unsigned int | BlockSize () const
| Provides the block size of the compression function. More...
std::string | AlgorithmName () const
| Provides the name of this algorithm. More...
Public Member Functions inherited from SHAKE
unsigned int | DigestSize () const
| Provides the digest size of the hash. More...
unsigned int | OptimalDataAlignment () const
| Provides input and output data alignment for optimal performance. More...
void | Update (const byte *input, size_t length)
| Updates a hash with additional input. More...
void | Restart ()
| Restart the hash. More...
void | TruncatedFinal (byte *hash, size_t size)
| Computes the hash of the current message. More...
Public Member Functions inherited from HashTransformation
HashTransformation & | Ref ()
| Provides a reference to this object. More...
virtual byte * | CreateUpdateSpace (size_t &size)
| Request space which can be written into by the caller. More...
virtual void | Final (byte *digest)
| Computes the hash of the current message. More...
unsigned int | TagSize () const
| Provides the tag size of the hash. More...
virtual unsigned int | OptimalBlockSize () const
| Provides the input block size most efficient for this hash. More...
virtual void | CalculateDigest (byte *digest, const byte *input, size_t length)
| Updates the hash with additional input and computes the hash of the current message. More...
virtual bool | Verify (const byte *digest)
| Verifies the hash of the current message. More...
virtual bool | VerifyDigest (const byte *digest, const byte *input, size_t length)
| Updates the hash with additional input and verifies the hash of the current message. More...
virtual void | CalculateTruncatedDigest (byte *digest, size_t digestSize, const byte *input, size_t length)
| Updates the hash with additional input and computes the hash of the current message. More...
virtual bool | TruncatedVerify (const byte *digest, size_t digestLength)
| Verifies the hash of the current message. More...
virtual bool | VerifyTruncatedDigest (const byte *digest, size_t digestLength, const byte *input, size_t length)
| Updates the hash with additional input and verifies the hash of the current message. More...
Public Member Functions inherited from Algorithm
| Algorithm (bool checkSelfTestStatus=true)
| Interface for all crypto algorithms. More...
virtual std::string | AlgorithmProvider () const
| Retrieve the provider of this algorithm. More...
Public Member Functions inherited from Clonable
virtual Clonable * | Clone () const
| Copies this object. More...

## Static Public Member Functions
static std::string | StaticAlgorithmName ()

## Static Public Attributes
static const int | DIGESTSIZE = (T_Strength == 128 ? 32 : 64)
static const int | BLOCKSIZE = (T_Strength == 128 ? 1344/8 : 1088/8)

## Detailed Description

### template<unsigned int T_Strength>
class SHAKE_Final< T_Strength >

SHAKE message digest template.

Template Parameters

  T_Strength | the strength of the digest

Since
  Crypto++ 8.1

Definition at line 66 of file shake.h.

## Constructor & Destructor Documentation

## ◆ SHAKE_Final()

template<unsigned int T_Strength>

SHAKE_Final< T_Strength >::SHAKE_Final | ( | unsigned int | outputSize = `DIGESTSIZE` | ) |
| inline

Construct a SHAKE-X message digest.

SHAKE128 and SHAKE256 don't need the output size in advance because the output size does not affect the digest. TruncatedFinal produces the correct digest for any output size. However, cSHAKE requires the output size in advance because the algoirthm uses output size as a parameter to the hash function.

Definition at line 80 of file shake.h.

## Member Function Documentation

## ◆ BlockSize()

template<unsigned int T_Strength>

unsigned int SHAKE_Final< T_Strength >::BlockSize | ( |  | ) | const
| inline virtual

Provides the block size of the compression function.

Returns
  block size of the compression function, in bytes

BlockSize() will return 0 if the hash is not block based or does not have an equivalent block size. For example, Keccak and SHA-3 do not have a block size, but they do have an equivalent to block size called rate expressed as `r`.

Reimplemented from HashTransformation.

Definition at line 88 of file shake.h.

## ◆ AlgorithmName()

template<unsigned int T_Strength>

std::string SHAKE_Final< T_Strength >::AlgorithmName | ( |  | ) | const
| inline virtual

Provides the name of this algorithm.

Returns
  the standard algorithm name

The standard algorithm name can be a name like `AES` or `AES/GCM`. Some algorithms do not have standard names yet. For example, there is no standard algorithm name for Shoup's ECIES.

Note
  AlgorithmName is not universally implemented yet.

Reimplemented from Algorithm.

Definition at line 90 of file shake.h.

The documentation for this class was generated from the following file:

- shake.h